package cat.hack3.codingtests.marsrover.ui.console;

import java.util.ServiceLoader;

public class UICommons {

    public static final String QUIT_COMMAND_TEXT = "q";

    static boolean isExitSignal(String nextCommand) {
        return QUIT_COMMAND_TEXT.equals(nextCommand);
    }

    static boolean isNotExitSignal(String nextCommand) {
        return !isExitSignal(nextCommand);
    }

    static void output(String message) {
        System.out.println(message);
    }

    static <T> T getImplProviderOf(Class<T> interfaceProvider) {
        return ServiceLoader
                .load(interfaceProvider)
                .findFirst()
                .orElseThrow();
    }
}
